#!/usr/bin/wishx
##############################
# tkwget
# a GUI front-end to wget
# by Sergio Nasi - May 1999 
##############################

# SETS INSTALLATION DIRECTORY
# WARNING: tkwget AND wgetsession MUST LIVE IN THE SAME DIRECTORY
set INSTALL_DIR "/usr/local/lib/tcltk/"
#                ^ CHANGE THE PATH TO SUIT YOUR REQUIREMENTS


# catches destroy window event 
wm protocol . WM_DELETE_WINDOW ExitApp

global vFrameOpt vArgs vCommand 

global vcbExecute veExecute vcbOutput veOutput vcbAppend veAppend \
       vcbInput veInput vcbTries veTries vcbOutputdoc veOutputdoc vcbDot veDot \
       vcbTimeout veTimeout vcbWait veWait vcbQuota veQuota vcbDirpref \
		 veDirpref vcbCutdirs veCutdirs vcbUser veUser vcbPass vePass vcbHeader \
		 veHeader vcbPruser vePruser vcbPrpass vePrpass vcbAgent veAgent \
		 vcbLevel veLevel vcbAccept veAccept vcbReject veReject vcbDomains \
		 veDomains vcbExcldomains veExcldomains vcbIncdirs veIncdirs \
		 vcbExcldirs veExcldirs


###############################
# PROCEDURE: InitDataStructures
###############################
proc InitDataStructures {} {

	global vFrameOpt vBinopt vArgs 

	set vFrameOpt 0
	set vArgs {}

}

########################
# PROCEDURE: InitWidgets
########################
proc InitWidgets {} {

	global vcbExecute veExecute vcbOutput veOutput vcbAppend veAppend \
			 vcbInput veInput vcbTries veTries vcbOutputdoc veOutputdoc vcbDot \
			 veDot vcbTimeout veTimeout vcbWait veWait vcbQuota veQuota \
 			 vcbDirpref veDirpref vcbCutdirs veCutdirs vcbUser veUser vcbPass \
 			 vePass vcbHeader veHeader vcbPruser vePruser vcbPrpass vePrpass \
 			 vcbAgent veAgent vcbLevel veLevel vcbAccept veAccept vcbReject \
			 veReject vcbDomains veDomains vcbExcldomains veExcldomains \
			 vcbIncdirs veIncdirs vcbExcldirs veExcldirs
			

	# set title and geometry
	wm title . "tkwget"
	wm geometry . 640x480
	
	# window cannot be resized
	wm resizable . 0 0  

	# let window maker generate a dockable icon
	wm group . .

	# neutral grey background
	. configure -bg grey

# FRAMES 
	frame .fBottom -borderwidth 2 -relief ridge
	frame .fCenterD -borderwidth 2 -relief ridge 
	frame .fCenterU -borderwidth 2 -relief ridge -bg lightblue 
	frame .fTop -borderwidth 2 -relief ridge

	# aligning frames for radiobuttons
	frame .fSub1 -bg lightblue
	frame .fSub2 -bg lightblue
	
# MENU
	frame .mbar -relief raised -bd 2
	frame .dummy -width 10c -height .5c
	menubutton .mbar.options -text Options -underline 0 -menu .mbar.options.menu
	menubutton .mbar.file -text File -underline 0 -menu .mbar.file.menu
	menubutton .mbar.help -text Help -underline 0 -menu .mbar.help.menu
	menu .mbar.file.menu
	menu .mbar.options.menu
	menu .mbar.help.menu
	.mbar.file.menu add command -label "Exit" -command ExitApp 
	.mbar.options.menu add command -label "Not implemented yet" \
											 -command "SetDefaults"
	.mbar.help.menu add command -label "About..." -command "ShowAbout"

# BOTTOM FRAME WIDGETS 
	label .lCmdLine -text "Command line check:" 
	entry .eCmdLine -width 200 -textvariable vArgs -state disabled
	button .bLaunch -text "LAUNCH!" -command cmdLaunch -bg red -foreground white


# RADIOBUTTONS 
	radiobutton .rFUOpt -text "Frequently Used Options" -variable vFrameOpt \
							  -value 0 -command ShowMainWindow -bg lightblue \
							  -highlightthickness 0

	radiobutton .rStartupOpt -text "Startup Options" -variable vFrameOpt \
									 -value 1 -command ShowMainWindow -bg lightblue \
									 -highlightthickness 0
	
	radiobutton .rLogOpt -text "Log & Input File Options" -variable vFrameOpt \
							   -value 2 -command ShowMainWindow -bg lightblue \
							   -highlightthickness 0

   radiobutton .rDownlOpt -text "Download Options" -variable vFrameOpt \
								  -value 3 -command ShowMainWindow -bg lightblue \
								  -highlightthickness 0

   radiobutton .rDirOpt -text "Directory Options" -variable vFrameOpt -value 4 \
                        -command ShowMainWindow -bg lightblue \
								-highlightthickness 0

   radiobutton .rHTTPOpt -text "HTTP Options" -variable vFrameOpt -value 5 \
                         -command ShowMainWindow -bg lightblue \
								 -highlightthickness 0

   radiobutton .rFTPOpt -text "FTP Options" -variable vFrameOpt -value 6 \
                        -command ShowMainWindow -bg lightblue \
								-highlightthickness 0

   radiobutton .rRecurOpt -text "Recursive Retrieval Options" \
								  -variable vFrameOpt -value 7 \
								  -command ShowMainWindow -bg lightblue \
								  -highlightthickness 0

   radiobutton .rAccRejOpt -text "Accept/Reject Options" -variable vFrameOpt \
									-value 8 -command ShowMainWindow -bg lightblue \
								   -highlightthickness 0


# OPTIONS WIDGETS : Frequently Used Options
	checkbutton .cbHelp -text help -variable vcbHelp -bg lightgreen \
							  -highlightthickness 0 
	checkbutton .cbVerbose -text verbose -variable vcbVerbose -bg lightgreen \
								  -highlightthickness 0 
	checkbutton .cbForceHtml -text "force html" -variable vcbForceHtml \
									 -bg lightgreen -highlightthickness 0 
	
	checkbutton .cbContinue -text continue -variable vcbContinue -bg lightgreen \
								   -highlightthickness 0	
	checkbutton .cbTimestamp -text timestamping -variable vcbTimeStamp \
									 -bg lightgreen -highlightthickness 0 
	checkbutton .cbNodirs -text "no dirs" -variable vcbNoDirs -bg lightgreen \
								 -highlightthickness 0 

	checkbutton .cbNohostdirs -text "no host dirs" -variable vcbNoHostDir \
									  -bg lightgreen -highlightthickness 0	
	checkbutton .cbSymlink -text "retrieve symlinks" -variable vcbSymlink \
								  -bg lightgreen -highlightthickness 0 
	checkbutton .cbRecursive -text "recursive" -variable vcbRecursive \
									 -bg lightgreen -highlightthickness 0 

	checkbutton .cbRelative -text relative -variable vcbRelative -bg lightgreen \
								   -highlightthickness 0	
	checkbutton .cbFollowFtp -text "follow ftp" -variable vcbFollowFtp \
									 -bg lightgreen -highlightthickness 0 
	checkbutton .cbNoparent -text "no parent" -variable vcbNoParent \
									-bg lightgreen -highlightthickness 0 

	label .lOutput -text "output file" -relief ridge -bg lightgreen \
						-highlightthickness 0 
	entry .eOutput -textvariable veOutput

	set vcbOutput [checkbutton .cbOutput -bg lightgreen -highlightthickness 0]
	
	label .lTries -text "tries" -relief ridge -bg lightgreen \
					  -highlightthickness 0
	
	entry .eTries -textvariable veTries
   set vcbTries [checkbutton .cbTries -bg lightgreen -highlightthickness 0]

	label .lTimeout -text "timeout" -relief ridge -bg lightgreen \
						 -highlightthickness 0
	entry .eTimeout  -textvariable veTimeout
   set vcbTimeout [checkbutton .cbTimeout -bg lightgreen -highlightthickness 0]

	label .lDirpref -text "directory prefix" -relief ridge -bg lightgreen \
						 -highlightthickness 0
	entry .eDirpref -textvariable veDirpref
	set vcbDirpref [checkbutton .cbDirpref -bg lightgreen -highlightthickness 0]

	label .lLevel -text "level" -relief ridge -bg lightgreen \
					  -highlightthickness 0
	entry .eLevel -textvariable veLevel
	set vcbLevel [checkbutton .cbLevel -bg lightgreen -highlightthickness 0]

	label .lAccept -text "accept" -relief ridge -bg lightgreen \
						-highlightthickness 0
	entry .eAccept -textvariable veAccept
	set vcbAccept [checkbutton .cbAccept -bg lightgreen -highlightthickness 0]

	label .lReject -text "reject" -relief ridge -bg lightgreen \
						-highlightthickness 0
	entry .eReject -textvariable veReject
   set vcbReject [checkbutton .cbReject -bg lightgreen -highlightthickness 0]

	label .lDot -text "dot style" -relief ridge -bg lightgreen \
					-highlightthickness 0
	entry .eDot -textvariable veDot
   set vcbDot [checkbutton .cbDot -bg lightgreen -highlightthickness 0] 
	

# OPTION WIDGETS : Startup Options
	checkbutton .cbVersion -text "version" -bg lightgreen -highlightthickness 0
	checkbutton .cbBackground -text "background" -bg lightgreen \
									  -highlightthickness 0

	label .lExecute -text "execute command" -relief ridge -bg lightgreen \
						 -highlightthickness 0 
	entry .eExecute -textvariable veExecute
	set vcbExecute [checkbutton .cbExecute -bg lightgreen -highlightthickness 0]
	

# OPTION WIDGETS : Log & Input File Options
   checkbutton .cbDebug -text "debug" -bg lightgreen -highlightthickness 0
   checkbutton .cbNverbose -text "non verbose" -bg lightgreen \
									-highlightthickness 0
	checkbutton .cbQuiet -text "quiet" -bg lightgreen -highlightthickness 0
	
	label .lAppend -text "append file" -relief ridge -bg lightgreen \
						-highlightthickness 0
	entry .eAppend -textvariable veAppend
	set vcbAppend [checkbutton .cbAppend -bg lightgreen -highlightthickness 0]

	label .lInput -text "input file" -relief ridge -bg lightgreen \
					  -highlightthickness 0
	entry .eInput -textvariable veInput
	set vcbInput [checkbutton .cbInput -bg lightgreen -highlightthickness 0]

# OPTION WIDGETS : Download  Options
   checkbutton .cbNoclob -text "no clobber" -bg lightgreen -highlightthickness 0
   checkbutton .cbServresp -text "server response" -bg lightgreen \
									-highlightthickness 0
   checkbutton .cbSpider -text "spider" -bg lightgreen -highlightthickness 0
	checkbutton .cbProxy -text "proxy on" -bg lightgreen -highlightthickness 0

	label .lOutputdoc -text "output doc" -relief ridge -bg lightgreen \
							-highlightthickness 0
	entry .eOutputdoc -textvariable veOutputdoc
	set vcbOutputdoc [checkbutton .cbOutputdoc -bg lightgreen \
															 -highlightthickness 0]

	label .lWait -text wait -relief ridge -bg lightgreen -highlightthickness 0
	entry .eWait -textvariable veWait
	set vcbWait [checkbutton .cbWait -bg lightgreen -highlightthickness 0]

	label .lQuota -text quota -relief ridge -bg lightgreen -highlightthickness 0
	entry .eQuota -textvariable veQuota
	set vcbQuota [checkbutton .cbQuota -bg lightgreen -highlightthickness 0]


# OPTION WIDGETS : Directories  Options
   checkbutton .cbForcedirs -text "force directories" -bg lightgreen \
									 -highlightthickness 0

	label .lCutdirs -text "cut dirs" -relief ridge -bg lightgreen \
						 -highlightthickness 0
	entry .eCutdirs -textvariable veCutdirs
	set vcbCutdirs [checkbutton .cbCutdirs -bg lightgreen -highlightthickness 0]

# OPTION WIDGETS : HTTP Options
   checkbutton .cbCache -text "cache on" -bg lightgreen -highlightthickness 0
   checkbutton .cbIgnorelen -text "ignore length" -bg lightgreen \
									 -highlightthickness 0
   checkbutton .cbSavehead -text "save headers" -bg lightgreen \
									-highlightthickness 0

   label .lUser -text "HTTP user" -relief ridge -bg lightgreen \
					 -highlightthickness 0
   entry .eUser -textvariable veUser
	set vcbUser [checkbutton .cbUser -bg lightgreen -highlightthickness 0]

   label .lPass -text "HTTP password" -relief ridge -bg lightgreen \
					 -highlightthickness 0
   entry .ePass -textvariable vePass
	set vcbPass [checkbutton .cbPass -bg lightgreen -highlightthickness 0]

   label .lHeader -text "header" -relief ridge -bg lightgreen \
						-highlightthickness 0
   entry .eHeader -textvariable veHeader
	set vcbHeader [checkbutton .cbHeader -bg lightgreen -highlightthickness 0]

	label .lPruser -text "proxy user" -relief ridge -bg lightgreen \
						-highlightthickness 0
	entry .ePruser -textvariable vePruser
	set vcbPruser [checkbutton .cbPruser -bg lightgreen -highlightthickness 0]

	label .lPrpass -text "proxy password" -relief ridge -bg lightgreen \
						-highlightthickness 0
   entry .ePrpass -textvariable vePrpass
	set vcbPrpass [checkbutton .cbPrpass -bg lightgreen -highlightthickness 0]

	label .lAgent -text "agent" -relief ridge -bg lightgreen \
					  -highlightthickness 0
	entry .eAgent -textvariable veAgent
	set vcbAgent [checkbutton .cbAgent -bg lightgreen -highlightthickness 0]
	
# OPTION WIDGETS : FTP Options
   checkbutton .cbGlob -text "globbing on" -bg lightgreen -highlightthickness 0
   checkbutton .cbPassive -text "passive FTP" -bg lightgreen \
								  -highlightthickness 0


# OPTION WIDGETS : Recursive Retrieval Options 
   checkbutton .cbDelete -text "delete after" -bg lightgreen \
								 -highlightthickness 0
	checkbutton .cbConvert -text "convert links" -bg lightgreen \
								  -highlightthickness 0
   checkbutton .cbMirror -text "mirror" -bg lightgreen -highlightthickness 0
	checkbutton .cbDontrem -text "don't remove listing" -bg lightgreen \
								  -highlightthickness 0

# OPTION WIDGETS : Recursive accept/reject Options
   checkbutton .cbSpan -text "span hosts" -bg lightgreen -highlightthickness 0
   checkbutton .cbNolookup -text "no host lookup" -bg lightgreen \
									-highlightthickness 0

	label .lDomains -text "domains" -relief ridge -bg lightgreen \
											  -highlightthickness 0
	entry .eDomains -textvariable veDomains
	set vcbDomains [checkbutton .cbDomains -bg lightgreen -highlightthickness 0]

	label .lExcldomains -text "exclude domains" -relief ridge -bg lightgreen \
							 -highlightthickness 0
   entry .eExcldomains -textvariable veExcldomains
	set vcbExcldomains [checkbutton .cbExcldomains -bg lightgreen \
																  -highlightthickness 0]

	label .lIncdirs -text "include dirs" -relief ridge -bg lightgreen \
						 -highlightthickness 0
	entry .eIncdirs -textvariable veIncdirs
	set vcbIncdirs [checkbutton .cbIncdirs -bg lightgreen -highlightthickness 0]

	label .lExcldirs -text "exclude dirs" -relief ridge -bg lightgreen \
						  -highlightthickness 0
	entry .eExcldirs -textvariable veExcldirs
	set vcbExcldirs [checkbutton .cbExcldirs -bg lightgreen \
														  -highlightthickness 0]


# TOP FRAME WIDGETS 
	label .lURL -text "URL:" -bg yellow -foreground black
	entry .eURL -relief sunken -bg lightyellow -foreground black \
					-textvariable vURL
}




###########################
# PROCEDURE: SetBindings 
###########################
proc SetBindings {} {

   global vcbExecute veExecute vcbOutput veOutput vcbAppend veAppend \
          vcbInput veInput vcbTries veTries vcbOutputdoc veOutputdoc vcbDot \
			 veDot vcbTimeout veTimeout vcbWait veWait vcbQuota veQuota \
			 vcbDirpref veDirpref vcbCutdirs veCutdirs vcbUser veUser vcbPass \
			 vePass vcbHeader veHeader vcbPruser vePruser vcbPrpass vePrpass \
			 vcbAgent veAgent vcbLevel veLevel vcbAccept veAccept vcbReject \
			 veReject vcbDomains veDomains vcbExcldomains veExcldomains \
			 vcbIncdirs veIncdirs vcbExcldirs veExcldirs

# binding binary options

	bind .cbVersion <Button> { InsertBinOpt -V }		

	bind .cbHelp <Button> { InsertBinOpt -h }

	bind .cbBackground <Button> { InsertBinOpt -b }

   bind .cbDebug <Button> { InsertBinOpt -d }
	
	bind .cbQuiet <Button> { InsertBinOpt -q }

	bind .cbVerbose <Button> { InsertBinOpt -v }

	bind .cbNverbose <Button> { InsertBinOpt -nv }

	bind .cbForceHtml <Button> { InsertBinOpt -F }

	bind .cbNoclob <Button> { InsertBinOpt -nc }

	bind .cbContinue <Button> { InsertBinOpt -c }

	bind .cbTimestamp <Button> { InsertBinOpt -N }

	bind .cbServresp <Button> { InsertBinOpt -S }

	bind .cbSpider <Button> { InsertBinOpt --spider }

	bind .cbProxy <Button> { InsertBinOpt -Y }

	bind .cbNodirs <Button> { InsertBinOpt -nd }

	bind .cbForcedirs <Button> { InsertBinOpt -x }

	bind .cbNohostdirs <Button> { InsertBinOpt -nH }

	bind .cbCache <Button> { InsertBinOpt -C }
	
	bind .cbIgnorelen <Button> { InsertBinOpt --ignore-length }

	bind .cbSavehead <Button> { InsertBinOpt -s }
	
	bind .cbSymlink <Button> { InsertBinOpt --retr-symlinks }
	
	bind .cbGlob <Button> { InsertBinOpt -g }
	
	bind .cbPassive <Button> { InsertBinOpt --passive-ftp }

	bind .cbRecursive <Button> { InsertBinOpt -r }

	bind .cbDelete <Button> { InsertBinOpt --delete-after }
	
	bind .cbConvert <Button> { InsertBinOpt -k }
	
	bind .cbMirror <Button> { InsertBinOpt -m }

	bind .cbDontrem <Button> { InsertBinOpt -nr }

	bind .cbRelative <Button> { InsertBinOpt -L }

	bind .cbFollowFtp <Button> { InsertBinOpt --follow-ftp}

	bind .cbSpan <Button> { InsertBinOpt -H }

	bind .cbNolookup <Button> { InsertBinOpt -nh }

	bind .cbNoparent <Button> { InsertBinOpt -np }


# binding parametric options
	bind .cbExecute <Button> { InsertParOpt $veExecute $vcbExecute -e }

	bind .cbOutput <Button> { InsertParOpt $veOutput $vcbOutput -o }

	bind .cbAppend <Button> { InsertParOpt $veAppend $vcbAppend -a }

	bind .cbInput <Button> { InsertParOpt $veInput $vcbInput -i }

	bind .cbTries <Button> { InsertParOpt $veTries $vcbTries -t }
			
	bind .cbOutputdoc <Button> { InsertParOpt $veOutputdoc $vcbOutputdoc -O }

	bind .cbDot <Button> { InsertParOpt $veDot $vcbDot --dot-style }

	bind .cbTimeout <Button> { InsertParOpt $veTimeout $vcbTimeout -T }

	bind .cbWait <Button> { InsertParOpt $veWait $vcbWait -w }

	bind .cbQuota <Button> { InsertParOpt $veQuota $vcbQuota -Q }

	bind .cbDirpref <Button> { InsertParOpt $veDirpref $vcbDirpref -P }	

	bind .cbCutdirs <Button> { InsertParOpt $veCutdirs $vcbCutdirs --cut-dirs }	

	bind .cbUser <Button> { InsertParOpt $veUser $vcbUser --http-user }	

	bind .cbPass <Button> { InsertParOpt $vePass $vcbPass --http-pass }	

	bind .cbHeader <Button> { InsertParOpt $veHeader $vcbHeader --header }	

	bind .cbPruser <Button> { InsertParOpt $vePruser $vcbPruser --proxy-user }	

	bind .cbPrpass <Button> { InsertParOpt $vePrpass $vcbPrpass --proxy-passwd }

	bind .cbAgent <Button> { InsertParOpt $veAgent $vcbAgent -U }
	
	bind .cbLevel <Button> { InsertParOpt $veLevel $vcbLevel -l }
	
	bind .cbAccept <Button> { InsertParOpt $veAccept $vcbAccept -A }

	bind .cbReject <Button> { InsertParOpt $veReject $vcbReject -R }

	bind .cbDomains <Button> { InsertParOpt $veDomains $vcbDomains -D }

	bind .cbExcldomains <Button> { InsertParOpt $veExcldomains $vcbExcldomains \
											 --exclude-domains } 
	bind .cbIncdirs <Button> { InsertParOpt $veIncdirs $vcbIncdirs -I }

	bind .cbExcldirs <Button> { InsertParOpt $veExcldirs $vcbExcldirs -X }

} 

###########################
# PROCEDURE: InsertBinOpt 
###########################
proc InsertBinOpt {aOpt} {

	global vArgs

	set lvTemp [lsearch $vArgs $aOpt]
	if {$lvTemp == -1} {
		set vArgs [concat $vArgs $aOpt]
	} else {
    	set vArgs [lreplace $vArgs $lvTemp $lvTemp]
	}

}

###########################
# PROCEDURE: InsertParOpt
###########################
proc InsertParOpt {aTextvar aButton aOpt} {

	global vArgs

	set lList [concat $aOpt]
	set lvIndex [lsearch $vArgs $aOpt]

	if {$lvIndex==-1} {
		if {$aTextvar==""} {
			$aButton configure -state disabled
		} else {
			$aButton configure -state active
#			set vArgs [concat $vArgs $aOpt $aTextvar]
			set vArgs [concat $vArgs $lList $aTextvar]
		}
	} else {
		set lvTemp [expr $lvIndex+1]
		set vArgs [lreplace $vArgs $lvTemp $lvTemp]
		set vArgs [lreplace $vArgs $lvIndex $lvIndex]

	}
}

###########################
# PROCEDURE: ShowMainWindow
###########################
proc ShowMainWindow {} {

	global vFrameOpt
	
	# packing non changing frames
	pack .mbar .dummy -side top -fill x
	pack .mbar.file .mbar.options -side left
	pack .mbar.help -side right
	pack .fBottom -side bottom -ipady 10 
	pack .fTop -side top -ipadx 230
	pack .fCenterU -side top -ipadx 150 
	pack .rFUOpt -in .fCenterU -side top
	pack .fSub1 -in .fCenterU -side left 
	pack .fSub2 -in .fCenterU -side right
	
	# packing widgets in bottom frame
	pack .bLaunch .eCmdLine  -in .fBottom -side bottom
	pack .lCmdLine -in .fBottom -side top 
	
	# selects which option frame to show
	switch $vFrameOpt {
		0 {ShowFUOpt}
		1 {ShowStartupOpt}
		2 {ShowLogOpt}
		3 {ShowDownlOpt}
		4 {ShowDirOpt}
		5 {ShowHTTPOpt}
		6 {ShowFTPOpt}
		7 {ShowRecurOpt}
		8 {ShowAccRejOpt}

	}

	# packing radio buttons
	pack .rStartupOpt .rLogOpt .rDownlOpt .rDirOpt -in .fSub1 -anchor w -ipadx 50
	pack .rHTTPOpt .rFTPOpt .rRecurOpt .rAccRejOpt -in .fSub2 -anchor w -ipadx 30

	# packing URL entry
	pack .lURL -in .fTop -side left
	pack .eURL -in .fTop -side left -expand 1 -fill x 

}	

######################
# PROCEDURE: ShowFUOpt
######################
proc ShowFUOpt {} {

   global vcbExecute veExecute vcbOutput veOutput vcbAppend veAppend \
			 vcbInput veInput vcbTries veTries vcbOutputdoc veOutputdoc vcbDot \
			 veDot vcbTimeout veTimeout vcbWait veWait vcbQuota veQuota \
			 vcbDirpref veDirpref vcbCutdirs veCutdirs vcbUser veUser vcbPass \
			 vePass vcbHeader veHeader vcbPruser vePruser vcbPrpass vePrpass \
			 vcbAgent veAgent vcbLevel veLevel vcbAccept veAccept vcbReject \
			 veReject vcbDomains veDomains vcbExcldomains veExcldomains \
			 vcbIncdirs veIncdirs vcbExcldirs veExcldirs

	# rebuild and redisplay the frame
	destroy .fCenterD
	frame .fCenterD -borderwidth 2 -relief ridge -bg lightgreen 
	pack .fCenterD -side bottom -ipady 200 -ipadx 340 
	
	# checkbuttons
	place .cbHelp -x 50 -y 20 -in .fCenterD 
	place .cbVerbose -x 50 -y 40 -in .fCenterD 
	place .cbForceHtml -x 50 -y 60 -in .fCenterD

	place .cbContinue -x 200 -y 20 -in .fCenterD
	place .cbTimestamp -x 200 -y 40 -in .fCenterD
	place .cbNodirs -x 200 -y 60 -in .fCenterD 

	place .cbNohostdirs -x 350 -y 20 -in .fCenterD
	place .cbSymlink -x 350 -y 40 -in .fCenterD
	place .cbRecursive -x 350 -y 60 -in .fCenterD

	place .cbRelative -x 500 -y 20 -in .fCenterD
	place .cbFollowFtp -x 500 -y 40 -in .fCenterD
	place .cbNoparent -x 500 -y 60 -in .fCenterD

	# labels and entries
	place .lOutput -x 10 -y 100 -in .fCenterD -width 100 
	place .eOutput -x 110 -y 100 -in .fCenterD
	place $vcbOutput -x 260 -y 100 -in .fCenterD
	
	place .lTries -x 10 -y 120 -in .fCenterD -width 100
	place .eTries -x 110 -y 120 -in .fCenterD
	place $vcbTries -x 260 -y 120 -in .fCenterD

	place .lTimeout -x 10 -y 140 -in .fCenterD -width 100
	place .eTimeout -x 110 -y 140 -in .fCenterD 
	place $vcbTimeout -x 260 -y 140 -in .fCenterD
	
	place .lDirpref -x 10 -y 160 -in .fCenterD -width 100
	place .eDirpref -x 110 -y 160 -in .fCenterD
	place $vcbDirpref -x 260 -y 160 -in .fCenterD

	place .lLevel -x 350 -y 100 -in .fCenterD -width 100
	place .eLevel -x 450 -y 100 -in .fCenterD
	place $vcbLevel -x 600 -y 100 -in .fCenterD
	
	place .lAccept -x 350 -y 120 -in .fCenterD -width 100
	place .eAccept -x 450 -y 120 -in .fCenterD
	place $vcbAccept -x 600 -y 120 -in .fCenterD
	
	place .lReject -x 350 -y 140 -in .fCenterD -width 100
	place .eReject -x 450 -y 140 -in .fCenterD
	place $vcbReject -x 600 -y 140 -in .fCenterD
	
	place .lDot -x 350 -y 160 -in .fCenterD -width 100
	place .eDot -x 450 -y 160 -in .fCenterD
	place $vcbDot -x 600 -y 160 -in .fCenterD
	
	
	# put containing frame into the background
	lower .fCenterD
}

###########################
# PROCEDURE: ShowStartupOpt
###########################
proc ShowStartupOpt {} {

   global vcbExecute veExecute vcbOutput veOutput vcbAppend veAppend \
			 vcbInput veInput vcbTries veTries vcbOutputdoc veOutputdoc vcbDot \
			 veDot vcbTimeout veTimeout vcbWait veWait vcbQuota veQuota \
			 vcbDirpref veDirpref vcbCutdirs veCutdirs vcbUser veUser vcbPass \
			 vePass vcbHeader veHeader vcbPruser vePruser vcbPrpass vePrpass \
			 vcbAgent veAgent vcbLevel veLevel vcbAccept veAccept vcbReject \
			 veReject vcbDomains veDomains vcbExcldomains veExcldomains \
			 vcbIncdirs veIncdirs vcbExcldirs veExcldirs

	# rebuild and redisplay the frame
   destroy .fCenterD
   frame .fCenterD -borderwidth 2 -relief ridge -bg lightgreen
   pack .fCenterD -side bottom -ipady 200 -ipadx 340
   
   # checkbuttons
   place .cbVersion -x 180 -y 20 -in .fCenterD
   place .cbHelp -x 300 -y 20 -in .fCenterD
   place .cbBackground -x 380 -y 20 -in .fCenterD

	# labels and entries
	place .lExecute -x 200 -y 60 -in .fCenterD -width 120
	place .eExecute -x 320 -y 60 -in .fCenterD
	place .cbExecute -x 470 -y 60 -in .fCenterD

	# put containing frame into the background
   lower .fCenterD
 

}


#######################
# PROCEDURE: ShowLogOpt
#######################
proc ShowLogOpt {} {

   global vcbExecute veExecute vcbOutput veOutput vcbAppend veAppend vcbInput \
			 veInput vcbTries veTries vcbOutputdoc veOutputdoc vcbDot veDot \
			 vcbTimeout veTimeout vcbWait veWait vcbQuota veQuota vcbDirpref \
			 veDirpref vcbCutdirs veCutdirs vcbUser veUser vcbPass vePass \
			 vcbHeader veHeader vcbPruser vePruser vcbPrpass vePrpass vcbAgent \
			 veAgent vcbLevel veLevel vcbAccept veAccept vcbReject veReject \
			 vcbDomains veDomains vcbExcldomains veExcldomains vcbIncdirs \
			 veIncdirs vcbExcldirs veExcldirs


	# rebuild and redisplay the frame
   destroy .fCenterD
   frame .fCenterD -borderwidth 2 -relief ridge -bg lightgreen
   pack .fCenterD -side bottom -ipady 200 -ipadx 340
  
   # checkbuttons
	place .cbDebug -x 50 -y 20 -in .fCenterD
   place .cbVerbose -x 150 -y 20 -in .fCenterD
   place .cbNverbose -x 260 -y 20 -in .fCenterD
 	place .cbQuiet -x 390 -y 20 -in .fCenterD
	place .cbForceHtml -x 490 -y 20 -in .fCenterD

   # labels and entries
   place .lOutput -x 200 -y 60 -in .fCenterD -width 120
   place .eOutput -x 320 -y 60 -in .fCenterD
   place .cbOutput -x 470 -y 60 -in .fCenterD

	place .lAppend -x 200 -y 80 -in .fCenterD -width 120
   place .eAppend -x 320 -y 80 -in .fCenterD
	place .cbAppend -x 470 -y 80 -in .fCenterD

   place .lInput -x 200 -y 100 -in .fCenterD -width 120
   place .eInput -x 320 -y 100 -in .fCenterD
	place .cbInput -x 470 -y 100 -in .fCenterD
   
	# put containing frame into the background
   lower .fCenterD
	
}


#########################
# PROCEDURE: ShowDownlOpt
#########################
proc ShowDownlOpt {} {

   global vcbExecute veExecute vcbOutput veOutput vcbAppend veAppend \
			 vcbInput veInput vcbTries veTries vcbOutputdoc veOutputdoc vcbDot \
			 veDot vcbTimeout veTimeout vcbWait veWait vcbQuota veQuota \
			 vcbDirpref veDirpref vcbCutdirs veCutdirs vcbUser veUser vcbPass \
			 vePass vcbHeader veHeader vcbPruser vePruser vcbPrpass vePrpass \
			 vcbAgent veAgent vcbLevel veLevel vcbAccept veAccept vcbReject \
			 veReject vcbDomains veDomains vcbExcldomains veExcldomains \
			 vcbIncdirs veIncdirs vcbExcldirs veExcldirs 
	

	# rebuild and redisplay the frame
   destroy .fCenterD
   frame .fCenterD -borderwidth 2 -relief ridge -bg lightgreen
   pack .fCenterD -side bottom -ipady 200 -ipadx 340

   # checkbuttons
   place .cbNoclob -x 190 -y 20 -in .fCenterD
   place .cbContinue -x 190 -y 40 -in .fCenterD
   place .cbTimestamp -x 190 -y 60 -in .fCenterD
   place .cbServresp -x 380 -y 20 -in .fCenterD
	place .cbSpider -x 380 -y 40 -in .fCenterD
	place .cbProxy -x 380 -y 60 -in .fCenterD	

	# labels and entries
   place .lTries -x 30 -y 100 -in .fCenterD -width 100
   place .eTries -x 130 -y 100 -in .fCenterD
   place .cbTries -x 280 -y 100 -in .fCenterD
	
	place .lOutputdoc -x 30 -y 120 -in .fCenterD -width 100
   place .eOutputdoc -x 130 -y 120 -in .fCenterD
   place .cbOutputdoc -x 280 -y 120 -in .fCenterD
	
	place .lDot -x 30 -y 140 -in .fCenterD -width 100
   place .eDot -x 130 -y 140 -in .fCenterD
	place .cbDot -x 280 -y 140 -in .fCenterD

   place .lWait -x 350 -y 100 -in .fCenterD -width 100
   place .eWait -x 450 -y 100 -in .fCenterD
	place .cbWait -x 600 -y 100 -in .fCenterD

   place .lTimeout -x 350 -y 120 -in .fCenterD -width 100
   place .eTimeout -x 450 -y 120 -in .fCenterD
	place .cbTimeout -x 600 -y 120 -in .fCenterD

   place .lQuota -x 350 -y 140 -in .fCenterD -width 100
   place .eQuota -x 450 -y 140 -in .fCenterD
	place .cbQuota -x 600 -y 140 -in .fCenterD	

   # put containing frame into the background
   lower .fCenterD


}

#########################
# PROCEDURE: ShowDirOpt
#########################
proc ShowDirOpt {} {

   global vcbExecute veExecute vcbOutput veOutput vcbAppend veAppend \
			 vcbInput veInput vcbTries veTries vcbOutputdoc veOutputdoc vcbDot \
			 veDot vcbTimeout veTimeout vcbWait veWait vcbQuota veQuota \
			 vcbDirpref veDirpref vcbCutdirs veCutdirs vcbUser veUser vcbPass \
			 vePass vcbHeader veHeader vcbPruser vePruser vcbPrpass vePrpass \
			 vcbAgent veAgent vcbLevel veLevel vcbAccept veAccept vcbReject \
			 veReject vcbDomains veDomains vcbExcldomains veExcldomains \
			 vcbIncdirs veIncdirs vcbExcldirs veExcldirs

   # rebuild and redisplay the frame
   destroy .fCenterD
   frame .fCenterD -borderwidth 2 -relief ridge -bg lightgreen
   pack .fCenterD -side bottom -ipady 200 -ipadx 340

	# checkbuttons
   place .cbNodirs -x 160 -y 20 -in .fCenterD
   place .cbForcedirs -x 280 -y 20 -in .fCenterD
   place .cbNohostdirs -x 440 -y 20 -in .fCenterD

   # labels and entries
   place .lDirpref -x 200 -y 60 -in .fCenterD -width 120
   place .eDirpref -x 320 -y 60 -in .fCenterD
	place .cbDirpref -x 470 -y 60 -in .fCenterD

	place .lCutdirs -x 200 -y 80 -in .fCenterD -width 120
	place .eCutdirs -x 320 -y 80 -in .fCenterD
	place .cbCutdirs -x 470 -y 80 -in .fCenterD


   # put containing frame into the background
   lower .fCenterD


}

#########################
# PROCEDURE: ShowHTTPOpt
#########################
proc ShowHTTPOpt {} {

   global vcbExecute veExecute vcbOutput veOutput vcbAppend veAppend \
			 vcbInput veInput vcbTries veTries vcbOutputdoc veOutputdoc vcbDot \
			 veDot vcbTimeout veTimeout vcbWait veWait vcbQuota veQuota \
			 vcbDirpref veDirpref vcbCutdirs veCutdirs vcbUser veUser vcbPass \
			 vePass vcbHeader veHeader vcbPruser vePruser vcbPrpass vePrpass \
			 vcbAgent veAgent vcbLevel veLevel vcbAccept veAccept vcbReject \
			 veReject vcbDomains veDomains vcbExcldomains veExcldomains \
			 vcbIncdirs veIncdirs vcbExcldirs veExcldirs

   # rebuild and redisplay the frame
   destroy .fCenterD
   frame .fCenterD -borderwidth 2 -relief ridge -bg lightgreen
   pack .fCenterD -side bottom -ipady 200 -ipadx 340

	# checkbuttons
   place .cbCache -x 160 -y 20 -in .fCenterD
   place .cbIgnorelen -x 280 -y 20 -in .fCenterD
   place .cbSavehead -x 440 -y 20 -in .fCenterD

   # labels and entries
   place .lUser -x 10 -y 100 -in .fCenterD -width 110
   place .eUser -x 120 -y 100 -in .fCenterD
   place .cbUser -x 270 -y 100 -in .fCenterD

	place .lPass -x 10 -y 120 -in .fCenterD -width 110
   place .ePass -x 120 -y 120 -in .fCenterD
	place .cbPass -x 270 -y 120 -in .fCenterD

	place .lHeader -x 10 -y 140 -in .fCenterD -width 110
   place .eHeader -x 120 -y 140 -in .fCenterD
	place .cbHeader -x 270 -y 140 -in .fCenterD
	
   place .lPruser -x 350 -y 100 -in .fCenterD -width 110
   place .ePruser -x 460 -y 100 -in .fCenterD
	place .cbPruser -x 610 -y 100 -in .fCenterD
   
	place .lPrpass -x 350 -y 120 -in .fCenterD -width 110
   place .ePrpass -x 460 -y 120 -in .fCenterD
	place .cbPrpass -x 610 -y 120 -in .fCenterD

	place .lAgent -x 350 -y 140 -in .fCenterD -width 110
   place .eAgent -x 460 -y 140 -in .fCenterD
	place .cbAgent -x 610 -y 140 -in .fCenterD
	

   # put containing frame into the background
   lower .fCenterD


}

#########################
# PROCEDURE: ShowFTPOpt
#########################
proc ShowFTPOpt {} {

   global vcbExecute veExecute vcbOutput veOutput vcbAppend veAppend \
			 vcbInput veInput vcbTries veTries vcbOutputdoc veOutputdoc vcbDot \
			 veDot vcbTimeout veTimeout vcbWait veWait vcbQuota veQuota \
			 vcbDirpref veDirpref vcbCutdirs veCutdirs vcbUser veUser vcbPass \
			 vePass vcbHeader veHeader vcbPruser vePruser vcbPrpass vePrpass \
			 vcbAgent veAgent vcbLevel veLevel vcbAccept veAccept vcbReject \
			 veReject vcbDomains veDomains vcbExcldomains veExcldomains \
			 vcbIncdirs veIncdirs vcbExcldirs veExcldirs


   # rebuild and redisplay the frame
   destroy .fCenterD
   frame .fCenterD -borderwidth 2 -relief ridge -bg lightgreen
   pack .fCenterD -side bottom -ipady 200 -ipadx 340

   # checkbuttons
   place .cbSymlink -x 140 -y 20 -in .fCenterD
   place .cbGlob -x 300 -y 20 -in .fCenterD
   place .cbPassive -x 420 -y 20 -in .fCenterD


   # put containing frame into the background
   lower .fCenterD


}

#########################
# PROCEDURE: ShowRecurOpt
#########################
proc ShowRecurOpt {} {

   global vcbExecute veExecute vcbOutput veOutput vcbAppend veAppend \
			 vcbInput veInput vcbTries veTries vcbOutputdoc veOutputdoc vcbDot \
			 veDot vcbTimeout veTimeout vcbWait veWait vcbQuota veQuota \
			 vcbDirpref veDirpref vcbCutdirs veCutdirs vcbUser veUser vcbPass \
			 vePass vcbHeader veHeader vcbPruser vePruser vcbPrpass vePrpass \
			 vcbAgent veAgent vcbLevel veLevel vcbAccept veAccept vcbReject \
			 veReject vcbDomains veDomains vcbExcldomains veExcldomains \
			 vcbIncdirs veIncdirs vcbExcldirs veExcldirs 

   # rebuild and redisplay the frame
   destroy .fCenterD
   frame .fCenterD -borderwidth 2 -relief ridge -bg lightgreen
   pack .fCenterD -side bottom -ipady 200 -ipadx 340

   # checkbuttons
   place .cbRecursive -x 40 -y 20 -in .fCenterD
   place .cbDelete -x 150 -y 20 -in .fCenterD
   place .cbConvert -x 265 -y 20 -in .fCenterD
   place .cbMirror -x 390 -y 20 -in .fCenterD
   place .cbDontrem -x 470 -y 20 -in .fCenterD

	# labels and entries
   place .lLevel -x 200 -y 60 -in .fCenterD -width 120
	place .eLevel -x 320 -y 60 -in .fCenterD
	place .cbLevel -x 470 -y 60 -in .fCenterD	


   # put containing frame into the background
   lower .fCenterD


}

#########################
# PROCEDURE: ShowAccRejOpt
#########################
proc ShowAccRejOpt {} {

   global vcbExecute veExecute vcbOutput veOutput vcbAppend veAppend \
			 vcbInput veInput vcbTries veTries vcbOutputdoc veOutputdoc vcbDot \
			 veDot vcbTimeout veTimeout vcbWait veWait vcbQuota veQuota \
			 vcbDirpref veDirpref vcbCutdirs veCutdirs vcbUser veUser vcbPass \
			 vePass vcbHeader veHeader vcbPruser vePruser vcbPrpass vePrpass \
			 vcbAgent veAgent vcbLevel veLevel vcbAccept veAccept vcbReject \
			 veReject vcbDomains veDomains vcbExcldomains veExcldomains \
			 vcbIncdirs veIncdirs vcbExcldirs veExcldirs

   # rebuild and redisplay the frame
   destroy .fCenterD
   frame .fCenterD -borderwidth 2 -relief ridge -bg lightgreen
   pack .fCenterD -side bottom -ipady 200 -ipadx 340

   # checkbuttons
   place .cbRelative -x 40 -y 20 -in .fCenterD
   place .cbFollowFtp -x 150 -y 20 -in .fCenterD
   place .cbSpan -x 265 -y 20 -in .fCenterD
   place .cbNolookup -x 390 -y 20 -in .fCenterD
   place .cbNoparent -x 520 -y 20 -in .fCenterD

   # labels and entries
   place .lAccept -x 10 -y 100 -in .fCenterD -width 110
   place .eAccept -x 120 -y 100 -in .fCenterD
	place .cbAccept -x 270 -y 100 -in .fCenterD

   place .lReject -x 10 -y 120 -in .fCenterD -width 110
   place .eReject -x 120 -y 120 -in .fCenterD
	place .cbReject -x 270 -y 120 -in .fCenterD

   place .lDomains -x 10 -y 140 -in .fCenterD -width 110
   place .eDomains -x 120 -y 140 -in .fCenterD
	place .cbDomains -x 270 -y 140 -in .fCenterD

   place .lExcldomains -x 350 -y 100 -in .fCenterD -width 110
   place .eExcldomains -x 460 -y 100 -in .fCenterD
	place .cbExcldomains -x 610 -y 100 -in .fCenterD

   place .lIncdirs -x 350 -y 120 -in .fCenterD -width 110
   place .eIncdirs -x 460 -y 120 -in .fCenterD
   place .cbIncdirs -x 610 -y 120 -in .fCenterD

   place .lExcldirs -x 350 -y 140 -in .fCenterD -width 110
   place .eExcldirs -x 460 -y 140 -in .fCenterD
   place .cbExcldirs -x 610 -y 140 -in .fCenterD

   # put containing frame into the background
   lower .fCenterD


}


######################
# PROCEDURE: cmdLaunch 
######################
proc cmdLaunch {} {

	global vCommand vURL vArgs INSTALL_DIR

	set lvCmdString [concat $vURL $vArgs]
	set lvpath [join {$INSTALL_DIR wgetsession.tcl} /]
	
	eval exec $lvpath  -- $vArgs $vURL &

}

######################
# PROCEDURE: SetDefaults 
######################
proc SetDefaults {} {

}

######################
# PROCEDURE: ShowAbout 
######################
proc ShowAbout {} {
	dialog .d {About tkwget} {TKWGET v0.1 Copyright (C) 1999 Sergio Nasi.\
									  TKWGET comes with ABSOLUTELY NO WARRANTY\
									  For details see file LICENSE.\
									  This is free software, and you are welcome to\
									  redistribute it under certain conditions.}\
				 {info} -1 OK
}


######################################################
# PROCEDURE: dialog
# taken from John Ousterhout's "Tcl and the Tk toolkit 
######################################################
proc dialog {w title text bitmap default args} {
	global button
	
	toplevel $w -class Dialog
	wm title $w $title
	wm iconname $w Dialog
	frame $w.top -relief raised -bd 1
	pack $w.top -side top -fill both
	frame $w.bot -relief raised -bd 1
	pack $w.bot -side bottom -fill both

	message $w.top.msg -width 3i -text $text
	pack $w.top.msg -side right -expand 1 -fill both\
						 -padx 3m -pady 3m
	if {$bitmap != ""} {
		label $w.top.bitmap -bitmap $bitmap
		pack $w.top.bitmap -side left -padx 3m -pady 3m
	}

	set i 0
	foreach but $args {
		button $w.bot.button$i -text $but -command\
					"set button $i"
		if {$i == $default} {
			frame $w.bot.default -relief sunken -bd 1
			raise $w.bot.button$i
			pack $w.bot.default -side left -expand 1\
						-padx 3m -pady 2m
			pack $w.bot.button$i -in $w.bot.default\
				  		-side left -padx 2m -pady 2m -ipadx 2m -ipady 1m
		} else {
			pack $w.bot.button$i -side left -expand 1\
						-padx 3m -pady 3m -ipadx 2m -ipady 1m
		}
		incr i
	}
	if {$default >= 0} {
		bind $w <Return> "$w.bot.button$default flash; \
				set button $default"
	}
	set oldFocus [focus]
	grab set $w
	focus $w

	tkwait variable button
	destroy $w
	focus $oldFocus
	return button

}
		



#######################
# PROCEDURE: KillZombie 
#######################
proc KillZombie aZombiePid {

	wait $aZombiePid

}

#######################
# PROCEDURE: ExitApp
#######################
proc ExitApp {} {
	catch {send wgetsession.tcl {destroy . } }
	exit 0
}	

# calling procedures
InitDataStructures
InitWidgets
SetBindings
ShowMainWindow
